# Enum rustc_hir_analysis::collect::resolve_bound_vars::Scope

source ·

    enum Scope<'a> {
        Binder {
            bound_vars: FxIndexMap<LocalDefId, ResolvedArg>,
            scope_type: BinderScopeType,
            hir_id: HirId,
            s: &'a Scope<'a>,
            where_bound_origin: Option<PredicateOrigin>,
        },
        Body {
            id: BodyId,
            s: &'a Scope<'a>,
        },
        ObjectLifetimeDefault {
            lifetime: Option<ResolvedArg>,
            s: &'a Scope<'a>,
        },
        Supertrait {
            bound_vars: Vec<BoundVariableKind>,
            s: &'a Scope<'a>,
        },
        TraitRefBoundary {
            s: &'a Scope<'a>,
        },
        LateBoundary {
            s: &'a Scope<'a>,
            what: &'static str,
        },
        Root {
            opt_parent_item: Option<LocalDefId>,
        },
    }

## Variants§

§

### Binder

Declares lifetimes, and each can be early-bound or late-bound. The `DebruijnIndex` of late-bound lifetimes starts at `1` and it should be shifted by the number of `Binder`s in between the declaration `Binder` and the location it’s referenced from.

#### Fields

§`bound_vars: FxIndexMap<LocalDefId, ResolvedArg>`

We use an IndexMap here because we want these lifetimes in order for diagnostics.

§`scope_type: BinderScopeType`
§`hir_id: HirId`

The late bound vars for a given item are stored by `HirId` to be queried later. However, if we enter an elision scope, we have to later append the elided bound vars to the list and need to know what to append to.

§`s: &'a Scope<'a>`
§`where_bound_origin: Option<PredicateOrigin>`

If this binder comes from a where clause, specify how it was created. This is used to diagnose inaccessible lifetimes in APIT:

ⓘ

    fn foo(x: impl for<'a> Trait<'a, Assoc = impl Copy + 'a>) {}

§

### Body

Lifetimes introduced by a fn are scoped to the call-site for that fn, if this is a fn body, otherwise the original definitions are used. Unspecified lifetimes are inferred, unless an elision scope is nested, e.g., `(&T, fn(&T) -> &T);` becomes `(&'_ T, for<'a> fn(&'a T) -> &'a T)`.

#### Fields

§`id: BodyId`
§`s: &'a Scope<'a>`
§

### ObjectLifetimeDefault

Use a specific lifetime (if `Some`) or leave it unset (to be inferred in a function body or potentially error outside one), for the default choice of lifetime in a trait object type.

#### Fields

§`lifetime: Option<ResolvedArg>`
§`s: &'a Scope<'a>`
§

### Supertrait

When we have nested trait refs, we concatenate late bound vars for inner trait refs from outer ones. But we also need to include any HRTB lifetimes encountered when identifying the trait that an associated type is declared on.

#### Fields

§`bound_vars: Vec<BoundVariableKind>`
§`s: &'a Scope<'a>`
§

### TraitRefBoundary

#### Fields

§`s: &'a Scope<'a>`
§

### LateBoundary

Disallows capturing late-bound vars from parent scopes.

This is necessary for something like `for<T> [(); { /* references T */ }]:`, since we don’t do something more correct like replacing any captured late-bound vars with early-bound params in the const’s own generics.

#### Fields

§`s: &'a Scope<'a>`
§`what: &'static str`
§

### Root

#### Fields

§`opt_parent_item: Option<LocalDefId>`

## Trait Implementations§

source§

### impl<'a> Debug for Scope<'a>

source§

#### fn fmt(&self, f: &mut Formatter<'_>) -> Result

Formats the value using the given formatter. Read more

## Auto Trait Implementations§

§

### impl<'a> DynSend for Scope<'a>

§

### impl<'a> DynSync for Scope<'a>

§

### impl<'a> Freeze for Scope<'a>

§

### impl<'a> RefUnwindSafe for Scope<'a>

§

### impl<'a> Send for Scope<'a>

§

### impl<'a> Sync for Scope<'a>

§

### impl<'a> Unpin for Scope<'a>

§

### impl<'a> UnwindSafe for Scope<'a>

## Blanket Implementations§

source§

### impl<T> Aligned for T

source§

#### const ALIGN: Alignment = _

Alignment of `Self`.
source§

### impl<T> Any for T
where T: 'static + ?Sized,

source§

#### fn type_id(&self) -> TypeId

Gets the `TypeId` of `self`. Read more
source§

### impl<T> Borrow<T> for T
where T: ?Sized,

source§

#### fn borrow(&self) -> &T

Immutably borrows from an owned value. Read more
source§

### impl<T> BorrowMut<T> for T
where T: ?Sized,

source§

#### fn borrow_mut(&mut self) -> &mut T

Mutably borrows from an owned value. Read more
source§

### impl<T, R> CollectAndApply<T, R> for T

source§

#### fn collect_and_apply<I, F>(iter: I, f: F) -> R
where I: Iterator<Item = T>, F: FnOnce(&[T]) -> R,

Equivalent to `f(&iter.collect::<Vec<_>>())`.

§

#### type Output = R

source§

### impl<T> Filterable for T

source§

#### fn filterable( self, filter_name: &'static str, ) -> RequestFilterDataProvider<T, fn(_: DataRequest<'_>) -> bool>

Creates a filterable data provider with the given name for debugging. Read more
source§

### impl<T> From<T> for T

source§

#### fn from(t: T) -> T

Returns the argument unchanged.

source§

### impl<T> Instrument for T

source§

#### fn instrument(self, span: Span) -> Instrumented<Self>

Instruments this type with the provided `Span`, returning an `Instrumented` wrapper. Read more
source§

#### fn in_current_span(self) -> Instrumented<Self>

Instruments this type with the current `Span`, returning an `Instrumented` wrapper. Read more
source§

### impl<T, U> Into<U> for T
where U: From<T>,

source§

#### fn into(self) -> U

Calls `U::from(self)`.

That is, this conversion is whatever the implementation of `From<T> for U` chooses to do.

source§

### impl<T> IntoEither for T

source§

#### fn into_either(self, into_left: bool) -> Either<Self, Self>

Converts `self` into a `Left` variant of `Either<Self, Self>` if `into_left` is `true`. Converts `self` into a `Right` variant of `Either<Self, Self>` otherwise. Read more
source§

#### fn into_either_with<F>(self, into_left: F) -> Either<Self, Self>
where F: FnOnce(&Self) -> bool,

Converts `self` into a `Left` variant of `Either<Self, Self>` if `into_left(&self)` returns `true`. Converts `self` into a `Right` variant of `Either<Self, Self>` otherwise. Read more
source§

### impl<P> IntoQueryParam<P> for P

source§

#### fn into_query_param(self) -> P

source§

### impl<T> MaybeResult<T> for T

§

#### type Error = !

source§

#### fn from(_: Result<T, <T as MaybeResult<T>>::Error>) -> T

source§

#### fn to_result(self) -> Result<T, <T as MaybeResult<T>>::Error>

source§

### impl<T> Pointable for T

source§

#### const ALIGN: usize = _

The alignment of pointer.
§

#### type Init = T

The type for initializers.
source§

#### unsafe fn init(init: <T as Pointable>::Init) -> usize

Initializes a with the given initializer. Read more
source§

#### unsafe fn deref<'a>(ptr: usize) -> &'a T

Dereferences the given pointer. Read more
source§

#### unsafe fn deref_mut<'a>(ptr: usize) -> &'a mut T

Mutably dereferences the given pointer. Read more
source§

#### unsafe fn drop(ptr: usize)

Drops the object pointed to by the given pointer. Read more
source§

### impl<T> Same for T

§

#### type Output = T

Should always be `Self`
source§

### impl<T, U> TryFrom<U> for T
where U: Into<T>,

§

#### type Error = Infallible

The type returned in the event of a conversion error.
source§

#### fn try_from(value: U) -> Result<T, <T as TryFrom<U>>::Error>

Performs the conversion.
source§

### impl<T, U> TryInto<U> for T
where U: TryFrom<T>,

§

#### type Error = <U as TryFrom<T>>::Error

The type returned in the event of a conversion error.
source§

#### fn try_into(self) -> Result<U, <U as TryFrom<T>>::Error>

Performs the conversion.
source§

### impl<I, T, U> Upcast<I, U> for T
where U: UpcastFrom<I, T>,

source§

#### fn upcast(self, interner: I) -> U

source§

### impl<I, T> UpcastFrom<I, T> for T

source§

#### fn upcast_from(from: T, _tcx: I) -> T

source§

### impl<V, T> VZip<V> for T
where V: MultiLane<T>,

source§

#### fn vzip(self) -> V

source§

### impl<Tcx, T> Value<Tcx> for T
where Tcx: DepContext,

source§

#### default fn from_cycle_error( tcx: Tcx, cycle_error: &CycleError, _guar: ErrorGuaranteed, ) -> T

source§

### impl<T> WithSubscriber for T

source§

#### fn with_subscriber<S>(self, subscriber: S) -> WithDispatch<Self>
where S: Into<Dispatch>,

Attaches the provided `Subscriber` to this type, returning a `WithDispatch` wrapper. Read more
source§

#### fn with_current_subscriber(self) -> WithDispatch<Self>

Attaches the current default `Subscriber` to this type, returning a `WithDispatch` wrapper. Read more
source§

### impl<'a, T> Captures<'a> for T
where T: ?Sized,

source§

### impl<T> ErasedDestructor for T
where T: 'static,

source§

### impl<T> MaybeSendSync for T
where T: Send + Sync,

## Layout§

Note: Most layout information is completely unstable and may even differ between compilations. The only exception is types with certain `repr(...)` attributes. Please see the Rust Reference's “Type Layout” chapter for details on type layout guarantees.

Size: 80 bytes

Size for each variant:

- `Binder`: 80 bytes
- `Body`: 24 bytes
- `ObjectLifetimeDefault`: 40 bytes
- `Supertrait`: 40 bytes
- `TraitRefBoundary`: 16 bytes
- `LateBoundary`: 32 bytes
- `Root`: 12 bytes